#include <iostream>
#include <sstream>
#include <gsl/gsl_matrix.h>
#include <gsl/gsl_vector.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_statistics_double.h>
#include <gsl/gsl_cdf.h>
#include <gsl/gsl_sort_vector.h>
#include <gsl/gsl_sort.h>

// macro definitions
#define VERSION "0.1 Jan 2019"
#define NNE 1

extern gsl_rng * r;
// function declarations
using namespace std;

struct dataset{
  int reps; // number of ABC sims
  int snp; // snp number to analyze (starting with 0)
  gsl_vector * varNe; // ne for M and L
  gsl_vector * t; // number of generations from M to ancestor and out to L
  double p0; // initial allele frequency
  int esth; // boolean, estimate het. effect (1 = yes, 0 = no), if no h = 0.5
  
};

struct parameters{
  double p; // simulated allele frequency
  double s; // selection coefficient
  double h; // heterozygote effect
  double sigma; // sd for normal prior on S
  int mod; // model, constrain S to be equal for L lines = 0, 1 = unconstrained
};


// function definitions
void usage(char * name);
void getdata(string file, dataset * data);
void wfsim(dataset * data, parameters * parm);
void sampleparms(dataset * data, parameters * parm);
double sim(dataset * data, parameters * parm);
double calcDp(double p, double s, double h);
